<?php

namespace Contabilidade\Logic\LancamentoLote;

use Contabilidade\Entities\Capalote;
use \Contabilidade\Entities\Rateccus;
use \Contabilidade\Entities\Lanclote;
use \Setforms2\Shared\Registry;
use \Geral\Util\DateUtil;

/**
 * Class Balancete
 * @package Contabilidade\Logic\Balancete\Balancete
 */
class LancamentoLote
{
    public static function insereLancLote($insereArquivo, $nrorg, $lote, $nrseqlanclote, $tipo){
        try {
            $cdoperador = \Geral\Util\Ambiente::getCdOperador();
            $data = substr(now(), 0, 10);
            $Lanclote = new Lanclote();
            $Lanclote->setCdempresa($insereArquivo['CDEMPRESA']);
            $Lanclote->setCdlote($lote);
            $Lanclote->setNrlanclote($insereArquivo['NRLANCLOTE']);
            $Lanclote->setNrorg($nrorg);
            $Lanclote->setNrseqlanlote($nrseqlanclote);
            if ($tipo == 'C') {
                $Lanclote->setVrlanclote($insereArquivo['VRLANCLOTE']);
                $Lanclote->setCdcontctbl($insereArquivo['CDCONTCTBLCRED']);
            }else{
                $Lanclote->setVrlanclote($insereArquivo['VRLANCLOTE'] * -1);
                $Lanclote->setCdcontctbl($insereArquivo['CDCONTCTBLDEB']);
            }
            $Lanclote->setCdhistpadr($insereArquivo['CDHISTPADR']);
            $Lanclote->setDtlanclote(self::formataData($insereArquivo['DTLANCLOTE']));
            $Lanclote->setDtinclusao(self::formataData($data));
            $Lanclote->setNrorgultatu($nrorg);
            $Lanclote->setNrorginclusao($nrorg);
            $Lanclote->setNrdoculote('00000000');
            $Lanclote->setDshistlote($insereArquivo['DSHISTLOTE']);
            $Lanclote->persist();
            Registry::getEntityManager()->flush();
        }catch(\Exception $e){
            Throw $e;
        }
    }

    public static function insereRateccus($insereArquivo, $nrorg, $lote, $nrseqlanclote, $tipo){
        try {
            $cdoperador = \Geral\Util\Ambiente::getCdOperador();
            $data = substr(now(), 0, 10);
            $rateccus = new Rateccus();
            $rateccus->setCdempresa($insereArquivo['CDEMPRESA']);
            $rateccus->setCdlote($lote);
            $rateccus->setNrlanclote($insereArquivo['NRLANCLOTE']);
            $rateccus->setNrorg($nrorg);
            $rateccus->setDtinclusao(self::formataData($data));
            $rateccus->setNrorgultatu($nrorg);
            $rateccus->setNrorginclusao($nrorg);
            if ($tipo == 'C') {
                $rateccus->setVrrateccus($insereArquivo['VRLANCLOTE']);
            }else{
                $rateccus->setVrrateccus($insereArquivo['VRLANCLOTE'] * -1);
            }
            $rateccus->setCdoperinclusao($cdoperador);
            $rateccus->setCdoperultatu($cdoperador);
            $rateccus->setNrseqlanlote($nrseqlanclote);
            $rateccus->setCdfilial($insereArquivo['CDFILIAL']);
            $rateccus->setCdcentcust($insereArquivo['CENTROCUSTO']);
            $rateccus->setDtcomprateccus($insereArquivo['DTLANCLOTE']);
            $rateccus->persist();
            Registry::getEntityManager()->flush();
        }catch(\Exception $e){
            Throw $e;
        }
    }

    public static function insereCapalote($nrorg, $lote){
        try {
            $cdoperador = \Geral\Util\Ambiente::getCdOperador();
            $data = substr(now(), 0, 10);
            $capalote = new Capalote();
            $capalote->setCdempresa(tk_get_field_value('CDEMPRESA'));
            $capalote->setCdlote($lote);
            $capalote->setNrorg($nrorg);
            $capalote->setDtinclusao(self::formataData($data));
            $capalote->setNrorgultatu($nrorg);
            $capalote->setNrorginclusao($nrorg);
            $capalote->setCdoperinclusao($cdoperador);
            $capalote->setCdoperultatu($cdoperador);
            $capalote->setDsobselote("Lote importado.");
            $capalote->setIdlote('D');
            $capalote->persist();
            Registry::getEntityManager()->flush();
        }catch(\Exception $e){
            Throw $e;
        }
    }

    public static function formataData($data){
        if(strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }

}
